/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 titlescreen.sc
 Contains the title screen room.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script TITLESCREEN_SCRIPT)
/******************************************************************************/
(use "main")
(use "game")
(use "menubar")
(use "obj")
(use "cycle")
(use "user")
(use "controls")
(use "feature")
(local
	random1
	goToRoom = 0
	randomcel
)
/******************************************************************************/
(instance public TitleScreen of Rm
	(properties
		picture 801
	//picture 801
	)
	(method (init)
        // Set up the title screen
		ProgramControl() 
		= gProgramControl FALSE
		(send gGame:setSpeed(1))
		(SL:disable())
		(TheMenuBar:hide())
	              
		(send gGame:setSpeed(7))
			
		(super:init())
		(self:setScript(RoomScript))
  (self:setRegions(802)) // Snowing
		
	//(esd:init()setPri(0))	
		
      Display("An Empty SAC Designed Production"  dsFONT 000 dsCOORD 59 161 dsCOLOUR clBLUE dsBACKGROUND clTRANSPARENT)
    Display("An Empty SAC Designed Production"  dsFONT 000 dsCOORD 58 160 dsCOLOUR clCYAN dsBACKGROUND clTRANSPARENT)
    Display("# 2012"  dsFONT 000 dsCOORD 139 171 dsCOLOUR clBLUE dsBACKGROUND clTRANSPARENT)
    Display("# 2012"  dsFONT 000 dsCOORD 138 170 dsCOLOUR clCYAN dsBACKGROUND clTRANSPARENT)
        /****************************************
         * Set up the room's music to play here *
         ****************************************/ /*
		(send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)       */

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/

	)
)
/******************************************************************************/
    
(instance RoomScript of Script
	(properties)
(method (doit)
  (super:doit())

  

  (if(<> goToRoom 0)
    UnLoad(rsPIC scriptNumber)
    UnLoad(rsSCRIPT scriptNumber)
    UnLoad(rsTEXT scriptNumber)
    UnLoad(rsSCRIPT 950) // pnc script    
    UnLoad(rsTEXT 950)   // pnc text
    UnLoad(rsVIEW 950)   // pnc views 
    // room specific
    UnLoad(rsVIEW 801) // 
    (send gRoom:newRoom(976))	
   )
  )// end method	
	
	
  (method (handleEvent pEvent)
  (super:handleEvent(pEvent))
    (if(==(send pEvent:type())evMOUSEBUTTON)  
      (if(not(& (send pEvent:modifiers) emRIGHT_BUTTON))// left clicks
       (if(== gProgramControl TRUE)(send pEvent:claimed(TRUE)))// do nuthin 
       (else
//****************************************************************************
//                       CLICKABLE AREA                                  
//****************************************************************************


	= goToRoom 4

//****************************************************************************
	
//****************************************************************************
	   )// end not program control
      )// end left click
    )// end mouse button
  )// end method
)// end instance
//*****************************************************************************


/******************************************************************************/
(instance carolers of Prop(properties x 260 y 189 cel 0 loop 1 view 801))
(instance elf of Prop(properties x 70 y 63 cel 0 loop 2 view 801))

(instance esd of Prop(properties x 163 y 164 cel 0 loop 0 view 0))
(instance snow1 of Act(properties x 360 y 400 cel 1 loop 0 view 801))
(instance snow2 of Act(properties x 360 y 400 cel 2 loop 0 view 801))
(instance snow3 of Act(properties x 360 y 400 cel 3 loop 0 view 801))
(instance snow4 of Act(properties x 360 y 400 cel 4 loop 0 view 801))
(instance snow5 of Act(properties x 360 y 400 cel 5 loop 0 view 801))
(instance snow6 of Act(properties x 360 y 400 cel 6 loop 0 view 801))
(instance snow7 of Act(properties x 360 y 400 cel 7 loop 0 view 801))
(instance snow8 of Act(properties x 360 y 400 cel 8 loop 0 view 801))
//*****************************************************************************
(instance snow1fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 0)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow1:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow1fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)

(instance snow2fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 15)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow2:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow2fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)

(instance snow3fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 30)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow3:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow3fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)
(instance snow4fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 45)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow4:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow4fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)
(instance snow5fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 60)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow5:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow5fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)
(instance snow6fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 75)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow6:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow6fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)
(instance snow7fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 90)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow7:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow7fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)
(instance snow8fall of Script
(properties)
  (method (changeState newState)
		(= state newState)
		(switch (newState)
			
			(case 0 = cycles 105)
			(case 1 
			   = random1 (Random(5 315))
			   = randomcel (Random(0 4))                                                        
               (snow8:ignoreActors()yStep(2)view(801)loop(0)posn(random1 0)setCycle(NULL)cel(randomcel)setMotion(MoveTo random1 185 snow8fall)show())   
			)
			(case 2 (self:changeState(1)))
		)
	)
)