//*****************************************************************************
//
//*****************************************************************************
(include "sci.sh")(include "game.sh")                                (script 4)
//*****************************************************************************
(use "main")(use "controls")(use "cycle")(use "game")(use "feature")(use "obj")
(use "menubar")
(local
	goToRoom = 0
startedUp = FALSE
beatPuzzle = FALSE
randomLayout
blank = 0

tileWidth = 40 // cel width + 1
tileHeight = 27 // cel height + 1
heightDiff = 3 // cels per row
rlDiff = 1 // cels side by side // always 1
 
position1
position2
position3
position4
position5
position6
position7
position8
)
//*****************************************************************************

//*****************************************************************************
(instance public rm004 of Rm
(properties picture scriptNumber)
  (method (init)
  (super:init())
 
		(SL:disable())
		(TheMenuBar:hide()) 
  
  (self:setScript(RoomScript))
  (self:setRegions(950)) // PnC Menu
  (self:setRegions(802)) // Snowing

 (elf1:addToPic()setPri(13)) 
 (elf2:addToPic()setPri(13))
 
 (tile1:init()setPri(5)) 
 (tile2:init()setPri(5))
 (tile3:init()setPri(5))

 (tile4:init()setPri(5))
 (tile5:init()setPri(5))
 (tile6:init()setPri(5))

 (tile7:init()setPri(5))
 (tile8:init()setPri(5))
 
   (send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)

  )// end method
)// end instance
//*****************************************************************************
(instance elf1 of Prop(properties x 53 y 145 cel 0 loop 0 view 4))
(instance elf2 of Prop(properties x 255 y 145 cel 1 loop 0 view 4))

(instance tile1 of Prop(properties x 400 y 400 cel 0 loop 4 view 3))
(instance tile2 of Prop(properties x 400 y 400 cel 1 loop 4 view 3))
(instance tile3 of Prop(properties x 400 y 400 cel 2 loop 4 view 3))

(instance tile4 of Prop(properties x 400 y 400 cel 3 loop 4 view 3))
(instance tile5 of Prop(properties x 400 y 400 cel 4 loop 4 view 3))
(instance tile6 of Prop(properties x 400 y 400 cel 5 loop 4 view 3))

(instance tile7 of Prop(properties x 400 y 400 cel 6 loop 4 view 3))
(instance tile8 of Prop(properties x 400 y 400 cel 7 loop 4 view 3))

(instance doBeatPuzzle of Script
(properties)
  (method (changeState newState)
   = state newState
   (switch (state)
       (case 0 Print("Congratulations, you have officially beat this puzzle.")
       	       ProgramControl()  
       	      
       	      (send gTheMusic:
			   prevSignal(0)
			   fade(4)
		      )
      	       = cycles 3)
       (case 1 = seconds 5)
       (case 2 Print("Since you are so good, how about we step it up a notch.")
       	      = cycles 5)
       (case 3 = goToRoom 3)
   )
  )
)
//*****************************************************************************
(instance RoomScript of Script
(properties)
  (method (doit)
  (super:doit())

(if(== beatPuzzle FALSE)
	(if(
	   (== position1 1) and (== position2 2) and (== position3 3) and
	   (== position4 4) and (== position5 5) and (== position6 6) and
	   (== position7 7) and (== position8 8) and (== blank 9)
	   )
	   = beatPuzzle TRUE
	   (tile1:setScript(doBeatPuzzle))// changestate...
	)
)
  
(if(== backToMenu TRUE)
  	= backToMenu FALSE
  	= goToRoom 803
 )
  (if(<> goToRoom 0)
    UnLoad(rsPIC scriptNumber)
    UnLoad(rsSCRIPT scriptNumber)
    UnLoad(rsTEXT scriptNumber)
    UnLoad(rsSCRIPT 950) // pnc script 
    UnLoad(rsSCRIPT 802) // snowing   
    UnLoad(rsTEXT 950)   // pnc text
    UnLoad(rsVIEW 950)   // pnc views 
    // room specific
    UnLoad(rsSOUND scriptNumber)
    UnLoad(rsVIEW 0)
    UnLoad(rsVIEW 1)
    UnLoad(rsVIEW 2)
    UnLoad(rsVIEW 3)
    UnLoad(rsVIEW 4)
    UnLoad(rsVIEW 5)
    UnLoad(rsVIEW 6)
    UnLoad(rsVIEW 7)
    (send gRoom:newRoom(goToRoom))	
   )
    
  (if(== startedUp FALSE)
  	Print("All of Santa's reindeer love to get in the Christmas spirit.\n\n Unscramble this puzzle for a peek at the fun.")
  	= startedUp TRUE
  	= randomLayout 0//Random(0 1)
  
    (switch(randomLayout)     // X: 109,149,189
	    (case 0               // Y: 47, 77, 104
	      (tile1:posn(109 104))
	      = position1 7 
          (tile2:posn(109 77))
	      = position2 4 
          (tile3:posn(109 50))
	      = position3 1 
 
          (tile4:posn(149 104))
	      = position4 8
	      (tile5:posn(149 77))
	      = position5 5 	      
          (tile6:posn(149 50))
	      = position6 2 

          (tile7:posn(189 104))
	      = position7 9 
          (tile8:posn(189 50))
	      = position8 3

	      		      
	      = blank 6  // 189 47	
	    )
 //   	(case 1  
    		
//    	)
	)	
  )

  )// end method
  (method (handleEvent pEvent)
  (super:handleEvent(pEvent))
    (if(==(send pEvent:type())evMOUSEBUTTON)  
      (if(not(& (send pEvent:modifiers) emRIGHT_BUTTON))// left clicks
       (if(== gProgramControl TRUE)(send pEvent:claimed(TRUE)))// do nuthin 
       (else
//****************************************************************************
//                       CLICKABLE AREA                                  
//****************************************************************************
(if((> (send pEvent:x) (tile1:nsLeft))and
    (< (send pEvent:x) (tile1:nsRight))and
    (> (send pEvent:y) (tile1:nsTop))and
    (< (send pEvent:y) (tile1:nsBottom)))
    (if(== blank (+ position1 heightDiff))
   	 = position1 (+ position1 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile1:y((+ (tile1:y) tileHeight)))
    )
    (else
    (if(== blank (- position1 heightDiff))
   	 = position1 (- position1 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile1:y((- (tile1:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position1 blank))
   	 = position1 (- position1 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile1:x((- (tile1:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position1))
   	 = position1 (+ position1 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile1:x((+ (tile1:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile2:nsLeft))and
    (< (send pEvent:x) (tile2:nsRight))and
    (> (send pEvent:y) (tile2:nsTop))and
    (< (send pEvent:y) (tile2:nsBottom)))
    (if(== blank (+ position2 heightDiff))
   	 = position2 (+ position2 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile2:y((+ (tile2:y) tileHeight)))
    )
    (else
    (if(== blank (- position2 heightDiff))
   	 = position2 (- position2 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile2:y((- (tile2:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position2 blank))
   	 = position2 (- position2 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile2:x((- (tile2:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position2))
   	 = position2 (+ position2 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile2:x((+ (tile2:x) tileWidth)))
    )
	)
	)
	)
)



(if((> (send pEvent:x) (tile3:nsLeft))and
    (< (send pEvent:x) (tile3:nsRight))and
    (> (send pEvent:y) (tile3:nsTop))and
    (< (send pEvent:y) (tile3:nsBottom)))
    (if(== blank (+ position3 heightDiff))
   	 = position3 (+ position3 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile3:y((+ (tile3:y) tileHeight)))
    )
    (else
    (if(== blank (- position3 heightDiff))
   	 = position3 (- position3 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile3:y((- (tile3:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position3 blank))
   	 = position3 (- position3 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile3:x((- (tile3:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position3))
   	 = position3 (+ position3 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile3:x((+ (tile3:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile4:nsLeft))and
    (< (send pEvent:x) (tile4:nsRight))and
    (> (send pEvent:y) (tile4:nsTop))and
    (< (send pEvent:y) (tile4:nsBottom)))
    (if(== blank (+ position4 heightDiff))
   	 = position4 (+ position4 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile4:y((+ (tile4:y) tileHeight)))
    )
    (else
    (if(== blank (- position4 heightDiff))
   	 = position4 (- position4 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile4:y((- (tile4:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position4 blank))
   	 = position4 (- position4 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile4:x((- (tile4:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position4))
   	 = position4 (+ position4 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile4:x((+ (tile4:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile5:nsLeft))and
    (< (send pEvent:x) (tile5:nsRight))and
    (> (send pEvent:y) (tile5:nsTop))and
    (< (send pEvent:y) (tile5:nsBottom)))
    (if(== blank (+ position5 heightDiff))
   	 = position5 (+ position5 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile5:y((+ (tile5:y) tileHeight)))
    )
    (else
    (if(== blank (- position5 heightDiff))
   	 = position5 (- position5 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile5:y((- (tile5:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position5 blank))
   	 = position5 (- position5 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile5:x((- (tile5:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position5))
   	 = position5 (+ position5 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile5:x((+ (tile5:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile6:nsLeft))and
    (< (send pEvent:x) (tile6:nsRight))and
    (> (send pEvent:y) (tile6:nsTop))and
    (< (send pEvent:y) (tile6:nsBottom)))
    (if(== blank (+ position6 heightDiff))
   	 = position6 (+ position6 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile6:y((+ (tile6:y) tileHeight)))
    )
    (else
    (if(== blank (- position6 heightDiff))
   	 = position6 (- position6 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile6:y((- (tile6:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position6 blank))
   	 = position6 (- position6 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile6:x((- (tile6:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position6))
   	 = position6 (+ position6 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile6:x((+ (tile6:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile7:nsLeft))and
    (< (send pEvent:x) (tile7:nsRight))and
    (> (send pEvent:y) (tile7:nsTop))and
    (< (send pEvent:y) (tile7:nsBottom)))
    (if(== blank (+ position7 heightDiff))
   	 = position7 (+ position7 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile7:y((+ (tile7:y) tileHeight)))
    )
    (else
    (if(== blank (- position7 heightDiff))
   	 = position7 (- position7 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile7:y((- (tile7:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position7 blank))
   	 = position7 (- position7 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile7:x((- (tile7:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position7))
   	 = position7 (+ position7 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile7:x((+ (tile7:x) tileWidth)))
    )
	)
	)
	)
)


(if((> (send pEvent:x) (tile8:nsLeft))and
    (< (send pEvent:x) (tile8:nsRight))and
    (> (send pEvent:y) (tile8:nsTop))and
    (< (send pEvent:y) (tile8:nsBottom)))
    (if(== blank (+ position8 heightDiff))
   	 = position8 (+ position8 heightDiff)
   	 = blank (- blank heightDiff)
   	 (tile8:y((+ (tile8:y) tileHeight)))
    )
    (else
    (if(== blank (- position8 heightDiff))
   	 = position8 (- position8 heightDiff)
   	 = blank (+ blank heightDiff)
   	 (tile8:y((- (tile8:y) tileHeight)))
    )
    (else
    (if(== rlDiff (- position8 blank))
   	 = position8 (- position8 rlDiff)
   	 = blank (+ blank rlDiff)
   	 (tile8:x((- (tile8:x) tileWidth)))
    )
    (else
    (if(== rlDiff (- blank position8))
   	 = position8 (+ position8 rlDiff)
   	 = blank (- blank rlDiff)
   	 (tile8:x((+ (tile8:x) tileWidth)))
    )
	)
	)
	)
)




/*
(if((> (send pEvent:x) 250) and
    (< (send pEvent:x) 320) and
    (> (send pEvent:y) 0) and
    (< (send pEvent:y) 150))
    FormatPrint("Blank: %u\nposition1: %u\nposition2: %u\nposition3: %u\nposition4: %u\nposition5: %u\nposition6: %u\nposition7: %u\nposition8: %u\nposition9: %u\nposition10: %u\nposition11: %u\nposition12: %u\nposition13: %u\nposition14: %u\nposition15: %u\n"
	             blank position1 position2 position3 position4 position5 position6 position7 position8 position9 position10 position11 position12 position13 position14 position15
	                  )
)
*/




//****************************************************************************
	
//****************************************************************************
	   )// end not program control
      )// end left click
    )// end mouse button
  )// end method
)// end instance
/******************************************************************************/
